/* gInfo - Copyright (C) 2004 bakunin - Andrea Marchesini 
 *                                      <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <ginfo_plugin.h>
#include <plugin.h>

int
module_default (void)
{
  return 1;
}

char *
module_name (void)
{
  return "gInfo";
}

int
module_genre (void)
{
  return GINFO_GENRE_SYSTEM;
}

char **
module_words (void)
{
  char **list;

  if (!(list = (char **) malloc (sizeof (char *) * 8)))
    ginfo_error ("Error: memory.");

  list[0] = "documentation";
  list[1] = "help";
  list[2] = "about";
  list[3] = "information";
  list[4] = "ginfo";
  list[5] = "software";
  list[6] = "howto";
  list[7] = NULL;

  return list;
}

/*

// WITHOUT GINFO_EASY_* FUNCTIONS:
ginfo_docs *
module_docs (int *n)
{
  ginfo_docs *list;

  if (!(list = (ginfo_docs *) malloc (sizeof (ginfo_docs) * 6)))
    ginfo_error ("Error: memory.");

  list[0].text = "Introduzione";
  list[0].func = create_intro;
  list[0].arg = NULL;

  list[1].text = "Installazione";
  list[1].func = create_install;
  list[1].arg = NULL;

  list[2].text = "Configurazione";
  list[2].func = create_config;
  list[2].arg = NULL;

  list[3].text = "API";
  list[3].func = create_api;
  list[3].arg = NULL;

  list[4].text = "Esempi";
  list[4].func = create_example;
  list[4].arg = NULL;

  list[5].text = "About";
  list[5].func = create_about;
  list[5].arg = NULL;

  *n = 6;

  return list;
}

WITH GINFO_EASY_* FUNCTIONS:
*/
ginfo_docs *
module_docs (int *n)
{
  void *t;

  t = ginfo_easy_docs_init ();

  ginfo_easy_docs_add (t, "Introduzione", create_intro, NULL);
  ginfo_easy_docs_add (t, "Installazione", create_install, NULL);
  ginfo_easy_docs_add (t, "Configurazione", create_config, NULL);
  ginfo_easy_docs_add (t, "API", create_api, NULL);
  ginfo_easy_docs_add (t, "Esempi", create_example, NULL);
  ginfo_easy_docs_add (t, "About", create_about, NULL);

  return ginfo_easy_docs_close (t, n);
}

/* WITHOUT GINFO_EASY_* FUNCTIONS: */

/*
ginfo_tips *
module_tooltips (int *n)
{
  ginfo_tips *list;

  if (!(list = (ginfo_tips *) malloc (sizeof (ginfo_tips) * 4)))
    ginfo_error ("Error: memory.");

  list[0].text =
    "gInfo ogni 5 minuti ti fornisce un tooltips!\nPuoi disattivarmi, ma se sei alle prime armi, non e' consigliato farlo.";
  list[0].func = create_intro;
  list[0].arg = NULL;

  list[1].text =
    "Lo sia che gInfo e' un prodotto altamente modulare!\nSe sei uno sviluppatore, scrivi anche tu il modulo per il tuo software!";
  list[1].func = create_intro;
  list[1].arg = NULL;

  list[2].text = "gInfo e' stato scritto da Andrea Marchesini\ne lo puoi scaricare al sito internet: http://autistici.org/bakunin/ginfo/!";
  list[2].func = create_intro;
  list[2].arg = NULL;

  list[3].text =
    "gInfo e' un software sotto GPL.\nConsulta il sito http://www.gnu.org per saperne di piu'.";
  list[3].func = create_intro;
  list[3].arg = NULL;

  *n = 4;

  return list;
}
*/

/* WITH GINFO_EASY_* FUNCTIONS: */

ginfo_tips *
module_tooltips (int *n)
{
  void *t;

  t = ginfo_easy_tips_init ();

  ginfo_easy_tips_add (t,
		       "gInfo ogni 5 minuti ti fornisce un tooltips!\nPuoi disattivarmi, ma se sei alle prime armi, non e' consigliato farlo.",
		       create_intro, NULL);
  ginfo_easy_tips_add (t,
		       "Lo sia che gInfo e' un prodotto altamente modulare!\nSe sei uno sviluppatore, scrivi anche tu il modulo per il tuo software!",
		       create_intro, NULL);
  ginfo_easy_tips_add (t,
		       "gInfo e' stato scritto da Andrea Marchesini\ne lo puoi scaricare al sito internet: http://autistici.org/bakunin/ginfo/!",
		       create_intro, NULL);
  ginfo_easy_tips_add (t,
		       "gInfo e' un software sotto GPL.\nConsulta il sito http://www.gnu.org per saperne di piu'.",
		       create_intro, NULL);

  return ginfo_easy_tips_close (t, n);
}
